<?

/*
 * Session Management for PHP3
 *
 * Copyright (c) 1998,1999 SH Online Dienst GmbH
 *						  Boris Erdmann, Kristian Koehntopp
 *
 * $Id: db_mysql.inc,v 1.15 1999/07/07 21:30:53 sts Exp $
 *
 */

if (eregi("db_mysql.inc.php", $_SERVER['PHP_SELF']))
{
	// redirect to calendar page
	header("Location: calendar.php");
	exit;
}

class DB_Sql 
{
  
  /* public: connection parameters */
  var $Host	  = "";
  var $Database = "";
  var $User	  = "";
  var $Password = "";

  /* public: configuration parameters */
  var $Auto_Free	  = 0;	  ## Set to 1 for automatic mysql_free_result()
  var $Debug			= 0;	  ## Set to 1 for debugging messages.
  var $Halt_On_Error = "no";  ## "yes" (halt with message), "no" (ignore errors quietly), "report" (ignore errror, but spit a warning)
  var $Seq_Table	  = "db_sequence";

  /* public: result array and current row number */
  var $Record	= array();
  var $Row;

  /* public: current error number and error text */
  var $Errno	 = 0;
  var $Error	 = "";

  /* public: identification constant. never change this. */
  var $type	  = "mysql";
  //var $revision = "\$Revision: 1.15 $";

  /* private: link and query handles */
  var $Link_ID  = 0;
  var $Query_ID = 0;

  /* public: some trivial reporting */
  function link_id() {
	 return $this->Link_ID;
  }

  function query_id() {
	 return $this->Query_ID;
  }

  /* public: connection management */
  function connect($Database = "", $Host = "", $User = "", $Password = "") {
	 /* Handle defaults */
	 if ("" == $Database)
		$Database = $this->Database;
	 if ("" == $Host)
		$Host	  = $this->Host;
	 if ("" == $User)
		$User	  = $this->User;
	 if ("" == $Password)
		$Password = $this->Password;
	 
	 /* establish connection, select database */
	 if ( 0 == $this->Link_ID ) {
		$this->Link_ID=MYSQL_CONNECT($Host, $User, $Password);
		if (!$this->Link_ID) {
		  $this->halt("pconnect($Host, $User, \$Password) failed.");
		}

		if (!@mysql_select_db($Database,$this->Link_ID)) {
		  $this->halt("cannot use database ".$this->Database);
		}
	 }
	 
	 return $this->Link_ID;
  }

  /* public: perform a query */
  function query($Query_String) {
	 $this->connect();

	 if ($this->Query_ID) {
		@mysql_free_result($this->Query_ID);
		$this->Query_ID = 0;
	 }

	 if ($this->Debug)
		printf("Debug: query = %s<br>\n", $Query_String);

	 $this->Query_ID = @mysql_query($Query_String,$this->Link_ID);
	 $this->Row	= 0;
//	 $this->Errno = mysql_errno();
//	 $this->Error = mysql_error();
	 if (!$this->Query_ID) {
		$this->halt("Invalid SQL: ".$Query_String);
	 }

	 return $this->Query_ID;
  }

  /* public: walk result set */
  function next_record() {
	 $this->Record = @mysql_fetch_array($this->Query_ID);
	 $this->Row	+= 1;
//	 $this->Errno  = mysql_errno();
//	 $this->Error  = mysql_error();

	 $stat = is_array($this->Record);
	 if (!$stat && $this->Auto_Free) {
		@mysql_free_result($this->Query_ID);
		$this->Query_ID = 0;
	 }
	 return $stat;
  }

  /* public: position in result set */
  function seek($pos = 0) {
	 $status = @mysql_data_seek($this->Query_ID, $pos);
	 if ($status)
		$this->Row = $pos;
	 else
		$this->halt("seek($pos) failed: result has ".$this->num_rows()." rows");

	 return;
  }

  /* public: table locking */
  function lock($table, $mode="write") {
	 $this->connect();
	 
	 $res = @mysql_query("lock tables $table $mode", $this->Link_ID);
	 if (!$res)
		$this->halt("lock($table, $mode) failed.");
	 return $res;
  }
  
  function unlock() {
	 $this->connect();

	 $res = @mysql_query("unlock tables");
	 if (!$res)
		$this->halt("unlock() failed.");
	 return $res;
  }


  /* public: evaluate the result (size, width) */
  function affected_rows() {
	 return @mysql_affected_rows($this->Link_ID);
  }

  function num_rows() {
	 return @mysql_num_rows($this->Query_ID);
  }

  function num_fields() {
	 return @mysql_num_fields($this->Query_ID);
  }

  /* public: shorthand notation */
  function nf() {
	 return $this->num_rows();
  }

  function np() {
	 print $this->num_rows();
  }

  function f($Name) {
	 return $this->Record[$Name];
  }

  function p($Name) {
	 print $this->Record[$Name];
  }

  /* public: sequence numbers */
  function nextid($seq_name) {
	 $this->connect();
	 
	 if ($this->lock($this->Seq_Table)) {
		/* get sequence number (locked) and increment */
		$q  = sprintf("select nextid from %s where seq_name = '%s'",
					 $this->Seq_Table,
					 $seq_name);
		$id  = @mysql_query($q, $this->Link_ID);
		$res = @mysql_fetch_array($id);
		
		/* No current value, make one */
		if (!is_array($res)) {
		  $currentid = 0;
		  $q = sprintf("insert into %s values('%s', %s)",
					  $this->Seq_Table,
					  $seq_name,
					  $currentid);
		  $id = @mysql_query($q, $this->Link_ID);
		} else {
		  $currentid = $res["nextid"];
		}
		$nextid = $currentid + 1;
		$q = sprintf("update %s set nextid = '%s' where seq_name = '%s'",
					$this->Seq_Table,
					$nextid,
					$seq_name);
		$id = @mysql_query($q, $this->Link_ID);
		$this->unlock();
	 } else {
		$this->halt("cannot lock ".$this->Seq_Table." - has it been created?");
	 }
	 return $nextid;
  }

  /* public: return table metadata */
  function metadata($table,$full=false) {
	 $count = 0;
	 $id	 = 0;
	 $res	= array();

	 /*
	  * Due to compatibility problems with Table we changed the behavior
	  * of metadata();
	  * depending on $full, metadata returns the following values:
	  *
	  * - full is false (default):
	  * $result[]:
	  *	[0]["table"]  table name
	  *	[0]["name"]	field name
	  *	[0]["type"]	field type
	  *	[0]["len"]	 field length
	  *	[0]["flags"]  field flags
	  *
	  * - full is true
	  * $result[]:
	  *	["num_fields"] number of metadata records
	  *	[0]["table"]  table name
	  *	[0]["name"]	field name
	  *	[0]["type"]	field type
	  *	[0]["len"]	 field length
	  *	[0]["flags"]  field flags
	  *	["meta"][field name]  index of field named "field name"
	  *	The last one is used, if you have a field name, but no index.
	  *	Test:  if (isset($result['meta']['myfield'])) { ...
	  */

	 $this->connect();
	 $id = @mysql_list_fields($this->Database, $table);
	 if (!$id)
		$this->halt("Metadata query failed.");

	 $count = @mysql_num_fields($id);

	 // made this IF due to performance (one if is faster than $count if's)
	 if (!$full) {
		for ($i=0; $i<$count; $i++) {
		  $res[$i]["table"] = @mysql_field_table ($id, $i);
		  $res[$i]["name"]  = @mysql_field_name  ($id, $i);
		  $res[$i]["type"]  = @mysql_field_type  ($id, $i);
		  $res[$i]["len"]	= @mysql_field_len	($id, $i);
		  $res[$i]["flags"] = @mysql_field_flags ($id, $i);
		}
	 } else { // full
		$res["num_fields"]= $count;
	 
		for ($i=0; $i<$count; $i++) {
		  $res[$i]["table"] = @mysql_field_table ($id, $i);
		  $res[$i]["name"]  = @mysql_field_name  ($id, $i);
		  $res[$i]["type"]  = @mysql_field_type  ($id, $i);
		  $res[$i]["len"]	= @mysql_field_len	($id, $i);
		  $res[$i]["flags"] = @mysql_field_flags ($id, $i);
		  $res["meta"][$res[$i]["name"]] = $i;
		}
	 }
	 
	 @mysql_free_result($id);
	 return $res;
  }

  /* private: error handling */
  function halt($msg) {
	 $this->Error = @mysql_error($this->Link_ID);
	 $this->Errno = @mysql_errno($this->Link_ID);
	 if ($this->Halt_On_Error == "no")
		return;

	 printf("</td></tr></table><b>Database error:</b> %s<br>\n", $msg);
	 printf("<b>MySQL Error</b>: %s (%s)<br>\n",
		$this->Errno,
		$this->Error);

	 if ($this->Halt_On_Error != "report")
		die("Session halted.");
  }

  function table_names() {
	 $this->query("SHOW TABLES");
	 $i=0;
	 while ($info=mysql_fetch_row($this->Query_ID))
	  {
		$return[$i]["table_name"]= $info[0];
		$return[$i]["tablespace_name"]=$this->Database;
		$return[$i]["database"]=$this->Database;
		$i++;
	  }
	return $return;
  }

  function getrows($query)
  {
	$aRet = Array();
	$myrow = 0;
	$this->query($query);
	while ($this->next_record())
	{
	 $aRet[$myrow] =$this->Record;
	 $myrow++;
	}
	return $aRet;
  }

  function InsertId()
  {
	 return mysql_insert_id($this->Link_ID);
  }
}
?>